import{S as no,i as lo,s as po,e as o,k as f,w as g,t as i,M as mo,c as t,d as a,m as c,a as s,x as b,h as n,b as p,N as fo,f as co,G as r,g as m,y,L as ho,q as z,o as v,B as P,v as uo}from"../chunks/vendor-hf-doc-builder.js";import{I as ce}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C as de}from"../chunks/CodeBlock-hf-doc-builder.js";function _o(za){let $,Ge,j,T,he,I,_r,ue,gr,De,L,br,_e,yr,zr,Ne,A,H,ge,q,vr,be,Pr,Ie,h,wr,ye,kr,$r,ze,jr,Ar,ve,xr,Cr,qe,U,Ue,w,Er,Pe,Mr,Or,we,Tr,Lr,Be,B,Ye,x,W,ke,Y,Hr,$e,Wr,Re,k,Fr,R,Vr,Sr,J,Gr,Dr,Je,K,Ke,u,Nr,je,Ir,qr,Q,Ur,Br,X,Yr,Rr,Qe,Z,Ae,va,Xe,C,F,xe,ee,Jr,Ce,Kr,Ze,ne,Qr,er,re,rr,E,V,Ee,ae,Xr,Me,Zr,ar,le,ea,or,oe,tr,M,S,Oe,te,ra,Te,aa,sr,G,d,oa,Le,ta,sa,He,ia,na,We,la,pa,Fe,ma,fa,Ve,ca,da,ha,O,ua,Se,_a,ga,se,ba,ya,ir,ie,nr;return I=new ce({}),q=new ce({}),U=new de({props:{code:`import torch
from transformers import GPT2Tokenizer
from trl import PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

# 1. load a pretrained model
model = AutoModelForCausalLMWithValueHead.from_pretrained('gpt2')
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained('gpt2')
tokenizer = GPT2Tokenizer.from_pretrained('gpt2')

# 2. define config
ppo_config = {'batch_size': 1, 'forward_batch_size': 1, 'learning_rate':1e-5}
config = PPOConfig(**ppo_config)


# 2. Create optimizer
optimizer = torch.optim.SGD(model.parameters(), lr=config.learning_rate)


# 3. initialize trainer
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer)`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPT2Tokenizer
<span class="hljs-keyword">from</span> trl <span class="hljs-keyword">import</span> PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

<span class="hljs-comment"># 1. load a pretrained model</span>
model = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)
tokenizer = GPT2Tokenizer.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)

<span class="hljs-comment"># 2. define config</span>
ppo_config = {<span class="hljs-string">&#x27;batch_size&#x27;</span>: <span class="hljs-number">1</span>, <span class="hljs-string">&#x27;forward_batch_size&#x27;</span>: <span class="hljs-number">1</span>, <span class="hljs-string">&#x27;learning_rate&#x27;</span>:<span class="hljs-number">1e-5</span>}
config = PPOConfig(**ppo_config)


<span class="hljs-comment"># 2. Create optimizer</span>
optimizer = torch.optim.SGD(model.parameters(), lr=config.learning_rate)


<span class="hljs-comment"># 3. initialize trainer</span>
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer)`}}),B=new de({props:{code:`import torch
import bitsandbytes as bnb

from transformers import GPT2Tokenizer
from trl import PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

# 1. load a pretrained model
model = AutoModelForCausalLMWithValueHead.from_pretrained('gpt2')
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained('gpt2')
tokenizer = GPT2Tokenizer.from_pretrained('gpt2')

# 2. define config
ppo_config = {'batch_size': 1, 'forward_batch_size': 1, 'learning_rate':1e-5}
config = PPOConfig(**ppo_config)


# 2. Create optimizer
optimizer = bnb.optim.Adam8bit(model.parameters(), lr=config.learning_rate)

# 3. initialize trainer
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer)`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">import</span> bitsandbytes <span class="hljs-keyword">as</span> bnb

<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPT2Tokenizer
<span class="hljs-keyword">from</span> trl <span class="hljs-keyword">import</span> PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

<span class="hljs-comment"># 1. load a pretrained model</span>
model = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)
tokenizer = GPT2Tokenizer.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)

<span class="hljs-comment"># 2. define config</span>
ppo_config = {<span class="hljs-string">&#x27;batch_size&#x27;</span>: <span class="hljs-number">1</span>, <span class="hljs-string">&#x27;forward_batch_size&#x27;</span>: <span class="hljs-number">1</span>, <span class="hljs-string">&#x27;learning_rate&#x27;</span>:<span class="hljs-number">1e-5</span>}
config = PPOConfig(**ppo_config)


<span class="hljs-comment"># 2. Create optimizer</span>
optimizer = bnb.optim.Adam8bit(model.parameters(), lr=config.learning_rate)

<span class="hljs-comment"># 3. initialize trainer</span>
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer)`}}),Y=new ce({}),K=new de({props:{code:"",highlighted:`optimizer = Lion(<span class="hljs-built_in">filter</span>(<span class="hljs-keyword">lambda</span> p: p.requires_grad, self.model.parameters()), lr=self.config.learning_rate)

...
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer)`}}),ee=new ce({}),re=new de({props:{code:`import torch
from transformers import GPT2Tokenizer
from trl import PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

# 1. load a pretrained model
model = AutoModelForCausalLMWithValueHead.from_pretrained('gpt2')
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained('gpt2')
tokenizer = GPT2Tokenizer.from_pretrained('gpt2')

# 2. define config
ppo_config = {'batch_size': 1, 'forward_batch_size': 1, 'learning_rate':1e-5}
config = PPOConfig(**ppo_config)


# 2. Create optimizer
optimizer = torch.optim.SGD(model.parameters(), lr=config.learning_rate)
lr_scheduler = lr_scheduler = torch.optim.lr_scheduler.ExponentialLR(optimizer, gamma=0.9)

# 3. initialize trainer
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer, lr_scheduler=lr_scheduler)`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPT2Tokenizer
<span class="hljs-keyword">from</span> trl <span class="hljs-keyword">import</span> PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

<span class="hljs-comment"># 1. load a pretrained model</span>
model = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)
tokenizer = GPT2Tokenizer.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)

<span class="hljs-comment"># 2. define config</span>
ppo_config = {<span class="hljs-string">&#x27;batch_size&#x27;</span>: <span class="hljs-number">1</span>, <span class="hljs-string">&#x27;forward_batch_size&#x27;</span>: <span class="hljs-number">1</span>, <span class="hljs-string">&#x27;learning_rate&#x27;</span>:<span class="hljs-number">1e-5</span>}
config = PPOConfig(**ppo_config)


<span class="hljs-comment"># 2. Create optimizer</span>
optimizer = torch.optim.SGD(model.parameters(), lr=config.learning_rate)
lr_scheduler = lr_scheduler = torch.optim.lr_scheduler.ExponentialLR(optimizer, gamma=<span class="hljs-number">0.9</span>)

<span class="hljs-comment"># 3. initialize trainer</span>
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer, lr_scheduler=lr_scheduler)`}}),ae=new ce({}),oe=new de({props:{code:`import torch
from transformers import AutoTokenizer
from trl import PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead, create_reference_model

# 1. load a pretrained model
model = AutoModelForCausalLMWithValueHead.from_pretrained('bigscience/bloom-560m')
model_ref = create_reference_model(model, num_shared_layers=6)
tokenizer = AutoTokenizer.from_pretrained('bigscience/bloom-560m')

# 2. initialize trainer
ppo_config = {'batch_size': 1, 'forward_batch_size': 1}
config = PPOConfig(**ppo_config)
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer)`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer
<span class="hljs-keyword">from</span> trl <span class="hljs-keyword">import</span> PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead, create_reference_model

<span class="hljs-comment"># 1. load a pretrained model</span>
model = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;bigscience/bloom-560m&#x27;</span>)
model_ref = create_reference_model(model, num_shared_layers=<span class="hljs-number">6</span>)
tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&#x27;bigscience/bloom-560m&#x27;</span>)

<span class="hljs-comment"># 2. initialize trainer</span>
ppo_config = {<span class="hljs-string">&#x27;batch_size&#x27;</span>: <span class="hljs-number">1</span>, <span class="hljs-string">&#x27;forward_batch_size&#x27;</span>: <span class="hljs-number">1</span>}
config = PPOConfig(**ppo_config)
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer)`}}),te=new ce({}),ie=new de({props:{code:`# 0. imports
# pip install bitsandbytes
import torch
from transformers import AutoTokenizer
from trl import PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

# 1. load a pretrained model
model = AutoModelForCausalLMWithValueHead.from_pretrained('bigscience/bloom-560m')
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained('bigscience/bloom-560m', device_map="auto", load_in_8bit=True)
tokenizer = AutoTokenizer.from_pretrained('bigscience/bloom-560m')

# 2. initialize trainer
ppo_config = {'batch_size': 1, 'forward_batch_size': 1}
config = PPOConfig(**ppo_config)
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer)`,highlighted:`<span class="hljs-comment"># 0. imports</span>
<span class="hljs-comment"># pip install bitsandbytes</span>
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer
<span class="hljs-keyword">from</span> trl <span class="hljs-keyword">import</span> PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

<span class="hljs-comment"># 1. load a pretrained model</span>
model = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;bigscience/bloom-560m&#x27;</span>)
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;bigscience/bloom-560m&#x27;</span>, device_map=<span class="hljs-string">&quot;auto&quot;</span>, load_in_8bit=<span class="hljs-literal">True</span>)
tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&#x27;bigscience/bloom-560m&#x27;</span>)

<span class="hljs-comment"># 2. initialize trainer</span>
ppo_config = {<span class="hljs-string">&#x27;batch_size&#x27;</span>: <span class="hljs-number">1</span>, <span class="hljs-string">&#x27;forward_batch_size&#x27;</span>: <span class="hljs-number">1</span>}
config = PPOConfig(**ppo_config)
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer)`}}),{c(){$=o("meta"),Ge=f(),j=o("h1"),T=o("a"),he=o("span"),g(I.$$.fragment),_r=f(),ue=o("span"),gr=i("Training customization"),De=f(),L=o("p"),br=i("At "),_e=o("code"),yr=i("trl"),zr=i(" we provide the possibility to give enough modularity to users to be able to efficiently customize the training loop for their needs. Below are some examples on how you can apply and test different techniques."),Ne=f(),A=o("h2"),H=o("a"),ge=o("span"),g(q.$$.fragment),vr=f(),be=o("span"),Pr=i("Use different optimizers"),Ie=f(),h=o("p"),wr=i("By default, the "),ye=o("code"),kr=i("PPOTrainer"),$r=i(" creates a "),ze=o("code"),jr=i("torch.optim.Adam"),Ar=i(" optimizer. You can create and define a different optimizer and pass it to "),ve=o("code"),xr=i("PPOTrainer"),Cr=i(":"),qe=f(),g(U.$$.fragment),Ue=f(),w=o("p"),Er=i("For memory efficient fine-tuning, you can also pass "),Pe=o("code"),Mr=i("Adam8bit"),Or=i(" optimizer from "),we=o("code"),Tr=i("bitsandbytes"),Lr=i(":"),Be=f(),g(B.$$.fragment),Ye=f(),x=o("h3"),W=o("a"),ke=o("span"),g(Y.$$.fragment),Hr=f(),$e=o("span"),Wr=i("Use LION optimizer"),Re=f(),k=o("p"),Fr=i("You can use the new "),R=o("a"),Vr=i("LION optimizer from Google"),Sr=i(" as well, first take the source code of the optimizer definition "),J=o("a"),Gr=i("here"),Dr=i(", and copy it so that you can import the optimizer. Make sure to initialize the optimizer by considering the trainable parameters only for a more memory efficient training:"),Je=f(),g(K.$$.fragment),Ke=f(),u=o("p"),Nr=i("We advice you to use the learning rate that you would use for "),je=o("code"),Ir=i("Adam"),qr=i(" divided by 3 as pointed out "),Q=o("a"),Ur=i("here"),Br=i(". We observed an improvement when using this optimizer compared to classic Adam (check the full logs "),X=o("a"),Yr=i("here"),Rr=i("):"),Qe=f(),Z=o("div"),Ae=o("img"),Xe=f(),C=o("h2"),F=o("a"),xe=o("span"),g(ee.$$.fragment),Jr=f(),Ce=o("span"),Kr=i("Add a learning rate scheduler"),Ze=f(),ne=o("p"),Qr=i("You can also play with your training by adding learning rate schedulers!"),er=f(),g(re.$$.fragment),rr=f(),E=o("h2"),V=o("a"),Ee=o("span"),g(ae.$$.fragment),Xr=f(),Me=o("span"),Zr=i("Memory efficient fine-tuning by sharing layers"),ar=f(),le=o("p"),ea=i("Another tool you can use for more memory efficient fine-tuning is to share layers between the reference model and the model you want to train."),or=f(),g(oe.$$.fragment),tr=f(),M=o("h2"),S=o("a"),Oe=o("span"),g(te.$$.fragment),ra=f(),Te=o("span"),aa=i("Pass 8-bit reference models"),sr=f(),G=o("div"),d=o("p"),oa=i("Since "),Le=o("code"),ta=i("trl"),sa=i(" supports all key word arguments when loading a model from "),He=o("code"),ia=i("transformers"),na=i(" using "),We=o("code"),la=i("from_pretrained"),pa=i(", you can also leverage "),Fe=o("code"),ma=i("load_in_8bit"),fa=i(" from "),Ve=o("code"),ca=i("transformers"),da=i(" for more memory efficient fine-tuning."),ha=f(),O=o("p"),ua=i("Read more about 8-bit model loading in "),Se=o("code"),_a=i("transformers"),ga=f(),se=o("a"),ba=i("here"),ya=i("."),ir=f(),g(ie.$$.fragment),this.h()},l(e){const l=mo('[data-svelte="svelte-1phssyn"]',document.head);$=t(l,"META",{name:!0,content:!0}),l.forEach(a),Ge=c(e),j=t(e,"H1",{class:!0});var lr=s(j);T=t(lr,"A",{id:!0,class:!0,href:!0});var Pa=s(T);he=t(Pa,"SPAN",{});var wa=s(he);b(I.$$.fragment,wa),wa.forEach(a),Pa.forEach(a),_r=c(lr),ue=t(lr,"SPAN",{});var ka=s(ue);gr=n(ka,"Training customization"),ka.forEach(a),lr.forEach(a),De=c(e),L=t(e,"P",{});var pr=s(L);br=n(pr,"At "),_e=t(pr,"CODE",{});var $a=s(_e);yr=n($a,"trl"),$a.forEach(a),zr=n(pr," we provide the possibility to give enough modularity to users to be able to efficiently customize the training loop for their needs. Below are some examples on how you can apply and test different techniques."),pr.forEach(a),Ne=c(e),A=t(e,"H2",{class:!0});var mr=s(A);H=t(mr,"A",{id:!0,class:!0,href:!0});var ja=s(H);ge=t(ja,"SPAN",{});var Aa=s(ge);b(q.$$.fragment,Aa),Aa.forEach(a),ja.forEach(a),vr=c(mr),be=t(mr,"SPAN",{});var xa=s(be);Pr=n(xa,"Use different optimizers"),xa.forEach(a),mr.forEach(a),Ie=c(e),h=t(e,"P",{});var D=s(h);wr=n(D,"By default, the "),ye=t(D,"CODE",{});var Ca=s(ye);kr=n(Ca,"PPOTrainer"),Ca.forEach(a),$r=n(D," creates a "),ze=t(D,"CODE",{});var Ea=s(ze);jr=n(Ea,"torch.optim.Adam"),Ea.forEach(a),Ar=n(D," optimizer. You can create and define a different optimizer and pass it to "),ve=t(D,"CODE",{});var Ma=s(ve);xr=n(Ma,"PPOTrainer"),Ma.forEach(a),Cr=n(D,":"),D.forEach(a),qe=c(e),b(U.$$.fragment,e),Ue=c(e),w=t(e,"P",{});var pe=s(w);Er=n(pe,"For memory efficient fine-tuning, you can also pass "),Pe=t(pe,"CODE",{});var Oa=s(Pe);Mr=n(Oa,"Adam8bit"),Oa.forEach(a),Or=n(pe," optimizer from "),we=t(pe,"CODE",{});var Ta=s(we);Tr=n(Ta,"bitsandbytes"),Ta.forEach(a),Lr=n(pe,":"),pe.forEach(a),Be=c(e),b(B.$$.fragment,e),Ye=c(e),x=t(e,"H3",{class:!0});var fr=s(x);W=t(fr,"A",{id:!0,class:!0,href:!0});var La=s(W);ke=t(La,"SPAN",{});var Ha=s(ke);b(Y.$$.fragment,Ha),Ha.forEach(a),La.forEach(a),Hr=c(fr),$e=t(fr,"SPAN",{});var Wa=s($e);Wr=n(Wa,"Use LION optimizer"),Wa.forEach(a),fr.forEach(a),Re=c(e),k=t(e,"P",{});var me=s(k);Fr=n(me,"You can use the new "),R=t(me,"A",{href:!0,rel:!0});var Fa=s(R);Vr=n(Fa,"LION optimizer from Google"),Fa.forEach(a),Sr=n(me," as well, first take the source code of the optimizer definition "),J=t(me,"A",{href:!0,rel:!0});var Va=s(J);Gr=n(Va,"here"),Va.forEach(a),Dr=n(me,", and copy it so that you can import the optimizer. Make sure to initialize the optimizer by considering the trainable parameters only for a more memory efficient training:"),me.forEach(a),Je=c(e),b(K.$$.fragment,e),Ke=c(e),u=t(e,"P",{});var N=s(u);Nr=n(N,"We advice you to use the learning rate that you would use for "),je=t(N,"CODE",{});var Sa=s(je);Ir=n(Sa,"Adam"),Sa.forEach(a),qr=n(N," divided by 3 as pointed out "),Q=t(N,"A",{href:!0,rel:!0});var Ga=s(Q);Ur=n(Ga,"here"),Ga.forEach(a),Br=n(N,". We observed an improvement when using this optimizer compared to classic Adam (check the full logs "),X=t(N,"A",{href:!0,rel:!0});var Da=s(X);Yr=n(Da,"here"),Da.forEach(a),Rr=n(N,"):"),N.forEach(a),Qe=c(e),Z=t(e,"DIV",{style:!0});var Na=s(Z);Ae=t(Na,"IMG",{src:!0}),Na.forEach(a),Xe=c(e),C=t(e,"H2",{class:!0});var cr=s(C);F=t(cr,"A",{id:!0,class:!0,href:!0});var Ia=s(F);xe=t(Ia,"SPAN",{});var qa=s(xe);b(ee.$$.fragment,qa),qa.forEach(a),Ia.forEach(a),Jr=c(cr),Ce=t(cr,"SPAN",{});var Ua=s(Ce);Kr=n(Ua,"Add a learning rate scheduler"),Ua.forEach(a),cr.forEach(a),Ze=c(e),ne=t(e,"P",{});var Ba=s(ne);Qr=n(Ba,"You can also play with your training by adding learning rate schedulers!"),Ba.forEach(a),er=c(e),b(re.$$.fragment,e),rr=c(e),E=t(e,"H2",{class:!0});var dr=s(E);V=t(dr,"A",{id:!0,class:!0,href:!0});var Ya=s(V);Ee=t(Ya,"SPAN",{});var Ra=s(Ee);b(ae.$$.fragment,Ra),Ra.forEach(a),Ya.forEach(a),Xr=c(dr),Me=t(dr,"SPAN",{});var Ja=s(Me);Zr=n(Ja,"Memory efficient fine-tuning by sharing layers"),Ja.forEach(a),dr.forEach(a),ar=c(e),le=t(e,"P",{});var Ka=s(le);ea=n(Ka,"Another tool you can use for more memory efficient fine-tuning is to share layers between the reference model and the model you want to train."),Ka.forEach(a),or=c(e),b(oe.$$.fragment,e),tr=c(e),M=t(e,"H2",{class:!0});var hr=s(M);S=t(hr,"A",{id:!0,class:!0,href:!0});var Qa=s(S);Oe=t(Qa,"SPAN",{});var Xa=s(Oe);b(te.$$.fragment,Xa),Xa.forEach(a),Qa.forEach(a),ra=c(hr),Te=t(hr,"SPAN",{});var Za=s(Te);aa=n(Za,"Pass 8-bit reference models"),Za.forEach(a),hr.forEach(a),sr=c(e),G=t(e,"DIV",{});var ur=s(G);d=t(ur,"P",{});var _=s(d);oa=n(_,"Since "),Le=t(_,"CODE",{});var eo=s(Le);ta=n(eo,"trl"),eo.forEach(a),sa=n(_," supports all key word arguments when loading a model from "),He=t(_,"CODE",{});var ro=s(He);ia=n(ro,"transformers"),ro.forEach(a),na=n(_," using "),We=t(_,"CODE",{});var ao=s(We);la=n(ao,"from_pretrained"),ao.forEach(a),pa=n(_,", you can also leverage "),Fe=t(_,"CODE",{});var oo=s(Fe);ma=n(oo,"load_in_8bit"),oo.forEach(a),fa=n(_," from "),Ve=t(_,"CODE",{});var to=s(Ve);ca=n(to,"transformers"),to.forEach(a),da=n(_," for more memory efficient fine-tuning."),_.forEach(a),ha=c(ur),O=t(ur,"P",{});var fe=s(O);ua=n(fe,"Read more about 8-bit model loading in "),Se=t(fe,"CODE",{});var so=s(Se);_a=n(so,"transformers"),so.forEach(a),ga=c(fe),se=t(fe,"A",{href:!0,rel:!0});var io=s(se);ba=n(io,"here"),io.forEach(a),ya=n(fe,"."),fe.forEach(a),ur.forEach(a),ir=c(e),b(ie.$$.fragment,e),this.h()},h(){p($,"name","hf:doc:metadata"),p($,"content",JSON.stringify(go)),p(T,"id","training-customization"),p(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(T,"href","#training-customization"),p(j,"class","relative group"),p(H,"id","use-different-optimizers"),p(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(H,"href","#use-different-optimizers"),p(A,"class","relative group"),p(W,"id","use-lion-optimizer"),p(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(W,"href","#use-lion-optimizer"),p(x,"class","relative group"),p(R,"href","https://arxiv.org/abs/2302.06675"),p(R,"rel","nofollow"),p(J,"href","https://github.com/lucidrains/lion-pytorch/blob/main/lion_pytorch/lion_pytorch.py"),p(J,"rel","nofollow"),p(Q,"href","https://github.com/lucidrains/lion-pytorch#lion---pytorch"),p(Q,"rel","nofollow"),p(X,"href","https://wandb.ai/distill-bloom/trl/runs/lj4bheke?workspace=user-younesbelkada"),p(X,"rel","nofollow"),fo(Ae.src,va="https://huggingface.co/datasets/trl-internal-testing/example-images/resolve/main/images/trl-lion.png")||p(Ae,"src",va),co(Z,"text-align","center"),p(F,"id","add-a-learning-rate-scheduler"),p(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(F,"href","#add-a-learning-rate-scheduler"),p(C,"class","relative group"),p(V,"id","memory-efficient-finetuning-by-sharing-layers"),p(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(V,"href","#memory-efficient-finetuning-by-sharing-layers"),p(E,"class","relative group"),p(S,"id","pass-8bit-reference-models"),p(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(S,"href","#pass-8bit-reference-models"),p(M,"class","relative group"),p(se,"href","https://huggingface.co/docs/transformers/perf_infer_gpu_one#bitsandbytes-integration-for-int8-mixedprecision-matrix-decomposition"),p(se,"rel","nofollow")},m(e,l){r(document.head,$),m(e,Ge,l),m(e,j,l),r(j,T),r(T,he),y(I,he,null),r(j,_r),r(j,ue),r(ue,gr),m(e,De,l),m(e,L,l),r(L,br),r(L,_e),r(_e,yr),r(L,zr),m(e,Ne,l),m(e,A,l),r(A,H),r(H,ge),y(q,ge,null),r(A,vr),r(A,be),r(be,Pr),m(e,Ie,l),m(e,h,l),r(h,wr),r(h,ye),r(ye,kr),r(h,$r),r(h,ze),r(ze,jr),r(h,Ar),r(h,ve),r(ve,xr),r(h,Cr),m(e,qe,l),y(U,e,l),m(e,Ue,l),m(e,w,l),r(w,Er),r(w,Pe),r(Pe,Mr),r(w,Or),r(w,we),r(we,Tr),r(w,Lr),m(e,Be,l),y(B,e,l),m(e,Ye,l),m(e,x,l),r(x,W),r(W,ke),y(Y,ke,null),r(x,Hr),r(x,$e),r($e,Wr),m(e,Re,l),m(e,k,l),r(k,Fr),r(k,R),r(R,Vr),r(k,Sr),r(k,J),r(J,Gr),r(k,Dr),m(e,Je,l),y(K,e,l),m(e,Ke,l),m(e,u,l),r(u,Nr),r(u,je),r(je,Ir),r(u,qr),r(u,Q),r(Q,Ur),r(u,Br),r(u,X),r(X,Yr),r(u,Rr),m(e,Qe,l),m(e,Z,l),r(Z,Ae),m(e,Xe,l),m(e,C,l),r(C,F),r(F,xe),y(ee,xe,null),r(C,Jr),r(C,Ce),r(Ce,Kr),m(e,Ze,l),m(e,ne,l),r(ne,Qr),m(e,er,l),y(re,e,l),m(e,rr,l),m(e,E,l),r(E,V),r(V,Ee),y(ae,Ee,null),r(E,Xr),r(E,Me),r(Me,Zr),m(e,ar,l),m(e,le,l),r(le,ea),m(e,or,l),y(oe,e,l),m(e,tr,l),m(e,M,l),r(M,S),r(S,Oe),y(te,Oe,null),r(M,ra),r(M,Te),r(Te,aa),m(e,sr,l),m(e,G,l),r(G,d),r(d,oa),r(d,Le),r(Le,ta),r(d,sa),r(d,He),r(He,ia),r(d,na),r(d,We),r(We,la),r(d,pa),r(d,Fe),r(Fe,ma),r(d,fa),r(d,Ve),r(Ve,ca),r(d,da),r(G,ha),r(G,O),r(O,ua),r(O,Se),r(Se,_a),r(O,ga),r(O,se),r(se,ba),r(O,ya),m(e,ir,l),y(ie,e,l),nr=!0},p:ho,i(e){nr||(z(I.$$.fragment,e),z(q.$$.fragment,e),z(U.$$.fragment,e),z(B.$$.fragment,e),z(Y.$$.fragment,e),z(K.$$.fragment,e),z(ee.$$.fragment,e),z(re.$$.fragment,e),z(ae.$$.fragment,e),z(oe.$$.fragment,e),z(te.$$.fragment,e),z(ie.$$.fragment,e),nr=!0)},o(e){v(I.$$.fragment,e),v(q.$$.fragment,e),v(U.$$.fragment,e),v(B.$$.fragment,e),v(Y.$$.fragment,e),v(K.$$.fragment,e),v(ee.$$.fragment,e),v(re.$$.fragment,e),v(ae.$$.fragment,e),v(oe.$$.fragment,e),v(te.$$.fragment,e),v(ie.$$.fragment,e),nr=!1},d(e){a($),e&&a(Ge),e&&a(j),P(I),e&&a(De),e&&a(L),e&&a(Ne),e&&a(A),P(q),e&&a(Ie),e&&a(h),e&&a(qe),P(U,e),e&&a(Ue),e&&a(w),e&&a(Be),P(B,e),e&&a(Ye),e&&a(x),P(Y),e&&a(Re),e&&a(k),e&&a(Je),P(K,e),e&&a(Ke),e&&a(u),e&&a(Qe),e&&a(Z),e&&a(Xe),e&&a(C),P(ee),e&&a(Ze),e&&a(ne),e&&a(er),P(re,e),e&&a(rr),e&&a(E),P(ae),e&&a(ar),e&&a(le),e&&a(or),P(oe,e),e&&a(tr),e&&a(M),P(te),e&&a(sr),e&&a(G),e&&a(ir),P(ie,e)}}}const go={local:"training-customization",sections:[{local:"use-different-optimizers",sections:[{local:"use-lion-optimizer",title:"Use LION optimizer"}],title:"Use different optimizers"},{local:"add-a-learning-rate-scheduler",title:"Add a learning rate scheduler"},{local:"memory-efficient-finetuning-by-sharing-layers",title:"Memory efficient fine-tuning by sharing layers"},{local:"pass-8bit-reference-models",title:"Pass 8-bit reference models "}],title:"Training customization"};function bo(za){return uo(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Po extends no{constructor($){super();lo(this,$,bo,_o,po,{})}}export{Po as default,go as metadata};
